library hex_alpha;

import 'package:flutter/material.dart';
import 'dart:math';
Color hexAlpha(String hex,double alpha){
  Map<String,int> hexToRemainder={
    '0':0,
    '1':1,
    '2':2,
    '3':3,
    '4':4,
    '5':5,
    '6':6,
    '7':7,
    '8':8,
    '9':9,
    'a':10,
    'b':11,
    'c':12,
    'd':13,
    'e':14,
    'f':15,
  };
  //Remove # from the hexadecimal value if exists
  if(hex.substring(0,1)=='#'){
    hex=hex.substring(1,hex.length);
  }else{
    //Stays the same
  }
  if(hex.length==6){
    //Continue, the hex is correct
  }else{
    throw('Hexadecimal color should be 6 characters long');
  }
  int hexToInt(String hexa){
    int dec=0;
    for(int x=hexa.length;x>0;x--){
      dec=dec+(hexToRemainder[hexa.substring(x-1,x)]*pow(16,hexa.length-x));
    }
    return dec;
  }
  int opacity(){
    if(alpha<0||alpha>1){
      throw('Alpha value cannot be smaller than 0 or greater than 1');
    }else{
      //Calculate alpha value for argb function
      return (255 * alpha).round();
    }
  }
  return Color.fromARGB(opacity(), hexToInt(hex.substring(0,2)), hexToInt(hex.substring(2,4)), hexToInt(hex.substring(4,6)));
}